// Copyright 2018 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

chrome.contextMenus.create({
  'title': '马上下',
  'contexts': ['selection'],
  'onclick': function(e) {
    console.log(e);
    var buzzPostUrl = 'https://wapp.flyoffline.com/?hash=';

    var match;
    if (e.selectionText && (match = /([A-Za-z0-9]{40})/.exec(e.selectionText))) {
      buzzPostUrl += match[1];
      chrome.tabs.create({'url': buzzPostUrl});
    } else {
      alert('无效的磁力链');
    }
  },
});

function sendMessageToContentScript(message, callback) {
  chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
    if (tabs.length > 0) {
      chrome.tabs.sendMessage(tabs[0].id, message, function(response) {
        if (callback) callback(response);
      });
    }
  });
}

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
  // console.log('收到来自content-script的消息：');
  // console.log(request, sender, sendResponse);
  // sendResponse('我是后台，我已收到你的消息：' + JSON.stringify(request));
  if (request['greeting']['action'] !== undefined) {
    if (request['greeting']['action'] === 'flyOfflineCookie') {
      for (var i = 0; i < request['greeting']['data'].length; i++) {
        var c = request['greeting']['data'][i];
        chrome.cookies.set({
          'url': 'http://115.com',
          'name': c['Name'],
          'domain': c['Domain'],
          'value': c['Value'],
          'path': c['Path'],
          'expirationDate': parseInt((new Date).getTime() / 1000 + 24 * 60 * 60 * 2),
        }, function(cookies) {
          // console.log(cookies);
          // console.log(chrome.runtime.lastError);
          // sendResponse('我是后台，我已收到你的消息：2');
          sendMessageToContentScript({cmd: 'flyOfflineCookie', value: true}, function(response) {
            console.log('来自content的回复：' + response);
          });
        });
      }

    }
  }

});